/*
  DLLが無くてもひとまず死なない

  ターゲット:DX/AX/RX/EX/MXシリーズ
*/

#include <stdio.h>
#include <conio.h>
#define _DYNAMICLOAD    // dxlib.hをインクルードする前に宣言
#include "dxlib.h"
#include "dxmemmap.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]
#define TIMEOUT     (50)            // 受信タイムアウト [ms]
#define TARGETID    (1)             // 対象となるID

void main (void) {
  TErrorCode  err;
  TDeviceID   dev;

  // DLLをロード
  if (LoadDLL ()) {
    if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
      DX_SetTimeOutOffset (dev, OFFSETTIME);

      while (!kbhit () && DX_Active (dev)) {
        uint16_t  dat;
        uint8_t   moving;

        // 最大トルクを約30%に制限
        DX_WriteWordData (dev, TARGETID, ADDRESS_TORQUE_LIMIT, 300, &err);

        // 400の位置へ移動
        if (DX_WriteWordData (dev, TARGETID, ADDRESS_GOAL_POSITION, 400, &err)) {
          do {
            // 移動中の現在位置を読み出す
            if (DX_ReadWordData (dev, TARGETID, ADDRESS_PRESENT_POSITION, &dat, &err)) printf ("\rpos:%4d", dat);
            else break;
            if (!DX_ReadByteData (dev, TARGETID, ADDRESS_MOVING, &moving, &err)) break;
            Sleep (20);
          } while (moving != 0 && !kbhit ());
        }

        // 600の位置へ移動
        if (DX_WriteWordData (dev, TARGETID, ADDRESS_GOAL_POSITION, 600, &err)) {
          do {
            // 移動中の現在位置を読み出す
            if (DX_ReadWordData (dev, TARGETID, ADDRESS_PRESENT_POSITION, &dat, &err)) printf ("\rpos:%4d", dat);
            else break;
            if (!DX_ReadByteData (dev, TARGETID, ADDRESS_MOVING, &moving, &err)) break;
            Sleep (20);
          } while (moving != 0 && !kbhit ());
        }
      }

      // 制御トルクの発生を停止
      DX_WriteByteData (dev, TARGETID, ADDRESS_TORQUE_ENABLE, 0, &err);

      DX_ClosePort (dev);
    } else {
      printf ("Open error\n");
    }

    // DLLをアンロード
    UnloadDLL ();
  } else {
    printf ("Fail to load DLL!\n");
  }
  printf ("Fin\n");
}
