/*
  PINGでネットワーク上の対象を検索

    PINGを全IDに対して発行
*/

#include <stdio.h>
#include <conio.h>
#include "dxlib.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]

void main (void) {
  TDeviceID   dev;
  TErrorCode  err;

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    DX_SetTimeOutOffset (dev, OFFSETTIME);
    printf ("Open success\n");

    int i;
    for (i = 0; (i <= 253) && !kbhit (); i++) {
      // PINGを発行
      if (DX_Ping (dev, i, &err)) {
        uint16_t model;
        // 見つかったIDのモデルNo(アドレス0)を読み出し
        if (DX_ReadWordData(dev, i, 0, &model, &err))
          printf ("\rFound ID=%d ModelNo=$%04X             \n", i, model);
      } else {
        printf ("\rNot found ID=%d [$%04X]", i, err);
      }
    }

    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }

  printf ("\nFin\n");
}
