/*
  PING2でネットワーク上の対象を検索

    PINGよりも検索時間が短いが確実ではない
*/

#include <stdio.h>
#include <conio.h>
#include "dxlib.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]

void main (void) {
  TDeviceID   dev;
  TErrorCode  err;

  TDxAlarmStatus stat[256];

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    printf ("Open success\n");
    DX_SetTimeOutOffset (dev, OFFSETTIME);

    for (int b = 0; b <= 254; b++){
      uint32_t baud = 2000000 / (b + 1);
      DX_SetBaudrate (dev, baud);
      printf("\rBaud(%d)=%d[bps]         ", b, baud);

      uint32_t num = 253;
      if (DX_Ping2 (dev, &num, stat, &err)) {
        printf ("\n %d device found\n", num);
        for (int i = 0; i < num; i++)
          printf (" Found ID=%d stat:$%04X\n", stat[i].id, stat[i].Status);
      }
    }
    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }

  printf ("Fin\n");
}
