/*
  BYTE幅のアイテムへのアクセス

  ターゲット:DX/AX/RX/EX/MXシリーズ
*/

#include <stdio.h>
#include "dxlib.h"
#include "dxmemmap.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]
#define TARGETID    (1)             // 対象となるID

void main (void) {
  TDeviceID   dev;
  TErrorCode  err;
  uint8_t     led;

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    printf ("Open success\n");

    for (int i = 0; i < 10; i++) {
      // LEDの状態を読み出し
      if (DX_ReadByteData (dev, TARGETID, ADDRESS_LED, &led, &err))
        printf ("Read LED=%d\n", led);
      else
        printf ("Read error [$%04X]\n", err);

      // 読み出したLEDの値を反転
      led ^= 1;

      // LEDへ値を書き込み
      if (DX_WriteByteData (dev, TARGETID, ADDRESS_LED, led, &err))
        printf ("Write LED=%d\n", led);
      else
        printf ("Write error [$%04X]\n", err);

      // 0.5秒待ち
      Sleep (500);
    }

    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
}
