/*
  WORD幅のアイテムへのアクセス

  ターゲット:DX/AX/RX/EX/MXシリーズ
*/

#include <stdio.h>
#include "dxlib.h"
#include "dxmemmap.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM10"  // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]
#define TARGETID    (1)             // 対象となるID

#define MAX_POS     (1023)
#define MIN_POS     (0)

void main (void) {
  int         f = 5;
  int         pos;
  TDeviceID   dev;
  TErrorCode  err;

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    printf("Open success\n");
    DX_SetTimeOutOffset (dev, OFFSETTIME);

    // 現在の位置を読み出し
    if (DX_ReadWordData (dev, TARGETID, ADDRESS_PRESENT_POSITION, (uint16_t *)&pos, &err)) {
      printf ("Now position = %4d\n", pos);
      // 何かキーを押すとループを抜ける
      while (!kbhit ()) {
        pos += f;
        if (pos >= MAX_POS) { pos = MAX_POS; f *= -1; }
        else if (pos <= MIN_POS) { pos = MIN_POS; f *= -1; }
        // 目標位置を書き込み
        if (DX_WriteWordData (dev, TARGETID, ADDRESS_GOAL_POSITION, (uint16_t)pos, &err))
          printf ("Sent position = %4d\r", pos);
        else
          printf ("Write error [$%04X]\n", err);
        // 5ミリ秒待ち
        Sleep (5);
      }
      printf ("\n");
    }

    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
}
