/*
  WORD幅のアイテムへのアクセス

  ターゲット:Xシリーズ
*/

#include <stdio.h>
#include <conio.h>
#include "dxlib.h"
#include "dxmemmap.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]
#define TARGETID    (2)             // 対象となるID

#define MAX_VELO     (200)
#define MIN_VELO     (-200)

void main (void) {
  int         f = 5;
  int         pos;
  TDeviceID   dev;
  TErrorCode  err;

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    printf("Open success\n");
    DX_SetTimeOutOffset (dev, OFFSETTIME);

    DX_WriteByteData (dev, TARGETID, ADDRESS_X_TORQUE_ENABLE, 1, &err);

    // 現在の位置を読み出し
    if (DX_ReadLongData (dev, TARGETID, ADDRESS_X_GOAL_VELOCITY, (uint32_t *)&pos, &err)) {
      printf ("Now position = %4d\n", pos);
      // 何かキーを押すとループを抜ける
      while (!kbhit ()) {
        pos += f;
        if (pos >= MAX_VELO) { pos = MAX_VELO; f *= -1; }
        else if (pos <= MIN_VELO) { pos = MIN_VELO; f *= -1; }
        // 目標位置を書き込み
        if (DX_WriteLongData (dev, TARGETID, ADDRESS_X_GOAL_VELOCITY, (uint32_t)pos, &err))
          printf ("Sent position = %4d\r", pos);
        else
          printf ("Write error [$%04X]\n", err);
        // 5ミリ秒待ち
        Sleep (100);
      }
      printf ("\n");
    }

    DX_WriteByteData (dev, TARGETID, ADDRESS_X_TORQUE_ENABLE, 0, &err);

    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
  getchar ();
}
