/*
  生パケットの送受信

  ターゲット:DX/AX/RX/EX/MXシリーズ
*/

#include <stdio.h>
#include <conio.h>
#include <process.h>
#include "dxlib.h"
#include "dxmemmap.h"

// マクロ定義
#define COMPORT     "\\\\.\\COM4"   // ポート番号
#define BAUDRATE    (57143)         // ボーレート[bps]
#define OFFSETTIME  (20)            // オフセット[ms]
#define TIMEOUT     (50)            // 受信タイムアウト [ms]
#define TARGETID    (1)             // 対象となるID

#define MAX_POS     (1023)
#define MIN_POS     (0)

void main (void) {
  TDeviceID dev;
  TErrorCode err;
  uint32_t l;
  uint8_t  param[10], rbuf[50];

  if ((dev = DX_OpenPort (COMPORT, BAUDRATE))) {
    printf ("Open success\n");
    DX_SetTimeOutOffset (dev, OFFSETTIME);

    while (!kbhit () && DX_Active (dev)) {
      printf ("TxPacket INST_WRITE\n");
      param[0] = ADDRESS_LED;
      param[1] = 1;
      if (DX_TxPacket (dev, TARGETID, INST_WRITE, param, 2, &err)) {
        printf ("RxPacket\n");
        if (!DX_RxPacket (dev, rbuf, sizeof (rbuf), &l, TIMEOUT, &err))
          printf ("error [$%04X]\n", err);
        for (int i = 0; i < l; i++) printf ("[%02X]", rbuf[i]);
        printf ("\n");
      } else
        printf ("error [$%04X]\n", err);

      printf ("TxPacket INST_READ\n");
      param[0] = ADDRESS_LED;
      param[1] = 5;
      if (DX_TxPacket (dev, TARGETID, INST_READ, param, 2, &err)) {
        printf ("RxPacket\n");
        if(!DX_RxPacket (dev, rbuf, sizeof (rbuf), &l, TIMEOUT, &err))
          printf ("error [$%04X]\n", err);
        for (int i = 0; i < l; i++) printf ("[%02X]", rbuf[i]);
        printf ("\n");
      } else
        printf ("error [$%04X]\n", err);

      Sleep(1000);

      printf ("TxPacket INST_WRITE\n");
      param[0] = ADDRESS_LED;
      param[1] = 0;
      if (DX_TxPacket (dev, TARGETID, INST_WRITE, param, 2, &err)) {
        printf ("RxPacket\n");
        if (!DX_RxPacket (dev, rbuf, sizeof (rbuf), &l, TIMEOUT, &err))
          printf ("error [$%04X]\n", err);
        for (int i = 0; i < l; i++) printf ("[%02X]", rbuf[i]);
        printf ("\n");
      } else
        printf ("error [$%04X]\n", err);

      printf ("TxPacket INST_READ\n");
      param[0] = ADDRESS_LED;
      param[1] = 10;
      if (DX_TxPacket (dev, TARGETID, INST_READ, param, 2, &err)) {
        printf ("RxPacket\n");
        if (!DX_RxPacket (dev, rbuf, sizeof (rbuf), &l, TIMEOUT, &err))
          printf ("error [$%04X]\n", err);
        for (int i = 0; i < l; i++) printf ("[%02X]", rbuf[i]);
        printf ("\n");
      } else
        printf ("error [$%04X]\n", err);

      Sleep(1000);
    }

    DX_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
}
